//**************************************************************//
//  Effect File exported by RenderMonkey 1.6
//
//  - Although many improvements were made to RenderMonkey FX  
//    file export, there are still situations that may cause   
//    compilation problems once the file is exported, such as  
//    occasional naming conflicts for methods, since FX format 
//    does not support any notions of name spaces. You need to 
//    try to create workspaces in such a way as to minimize    
//    potential naming conflicts on export.                    
//    
//  - Note that to minimize resulting name collisions in the FX 
//    file, RenderMonkey will mangle names for passes, shaders  
//    and function names as necessary to reduce name conflicts. 
//**************************************************************//

//--------------------------------------------------------------//
// ColorConversion
//--------------------------------------------------------------//
//--------------------------------------------------------------//
// Edge
//--------------------------------------------------------------//
string ColorConversion_Edge_ScreenAlignedQuad : ModelData = "C:\\Program Files (x86)\\AMD\\RenderMonkey 1.82\\Examples\\Media\\Models\\ScreenAlignedQuad.3ds";

struct VS_INPUT 
{
   float4 pos : POSITION0;
   float2 uv : TEXCOORD0; 
};

struct VS_OUTPUT 
{
   float4 pos : POSITION0;
   float2 uv : TEXCOORD0;
};

VS_OUTPUT ColorConversion_Edge_Vertex_Shader_vs_main( VS_INPUT input )
{
   VS_OUTPUT output;

   output.pos = input.pos;
   output.uv = input.uv;
   
   return( output );
}




struct PS_INPUT
{
   float2 uv : TEXCOORD0;
};

float3x3 convX = { -1, 0, 1,
                   -2, 0, 2,
                   -1, 0, 1};
                     
float3x3 convY = { 1, 2, 1,
                   0, 0, 0,
                  -1, -2, -1};                     
   
float2 gPixelOffset : ViewportDimensionsInverse;
   
texture SceneTexture_Tex
<
   string ResourceName = ".\\";
>;
sampler2D SceneSampler = sampler_state
{
   Texture = (SceneTexture_Tex);
};

float4 ColorConversion_Edge_Pixel_Shader_ps_main( PS_INPUT input) : COLOR
{   
   float lx = 0;
   float ly = 0;
  
   for(int y = -1; y <= 1; ++y) 
   {
      for(int x = -1; x <= 1; ++x)
      {
         float2 offset = float2(x, y) * gPixelOffset;
         float3 tex = tex2D( SceneSampler, input.uv + offset).rgb;
         float luminace = dot(tex, float3( 0.3, 0.59, 0.11));
      
         lx += luminace * convX[y+1][x+1];
         ly += luminace * convY[y+1][x+1];
      }
   }
   
   float l = sqrt(( lx*lx) + (ly*ly));
   return float4( l.xxx, 1);
}




//--------------------------------------------------------------//
// Technique Section for ColorConversion
//--------------------------------------------------------------//
technique ColorConversion
{
   pass Edge
   {
      CULLMODE = NONE;

      VertexShader = compile vs_2_0 ColorConversion_Edge_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 ColorConversion_Edge_Pixel_Shader_ps_main();
   }

}

